=== debian/changelog ===
ros-galactic-hpp-fcl (2.1.3-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Joseph Mirabel <jmirabel@laas.fr>  Tue, 13 Sep 2022 17:57:07 -0000
